SystemOrganization addCategory: #'TP2-Metaprogramacion-2.5'!
SystemOrganization addCategory: #'TP2-Metaprogramacion-2.5-Test'!
SystemOrganization addCategory: #'TP2-Metaprogramacion-2.5-Test-Fixture'!

TestCase subclass: #PasarCompositeATraits
	instanceVariableNames: 'unA unB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test'!

!PasarCompositeATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 10:27'!
setUp 
MetaUtil recreateCategory: 'TP2-Metaprogramacion-2.5-Test-Fixture'.
unA := A new.
unB := B new.
unA composite: unB.! !

!PasarCompositeATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 10:11'!
tearDown 
"Limpiar las clases para iniciar nuevamente el test"
"Ahora no estoy borrando nada porque me interesa ver como quedaron las clases que se modificaron, en el metodo setUp se esta recreando la categoria fixture que contiene las clases para la prueba"! !

!PasarCompositeATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:15'!
testCreaTraitsAPartirDeCompositeBasico
|unConvertidorATraits resultadoSinTraits|
resultadoSinTraits := unA composite mensajeSimple.

unConvertidorATraits := ConvertidorATraits new.
unConvertidorATraits refactorATraitsDe: unA conComposite: unB.

self assert: (resultadoSinTraits == unA mensajeSimple).
  ! !

Object subclass: #A
	instanceVariableNames: 'composite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test-Fixture'!

!A commentStamp: '<historical>' prior: 0!
An A is a fixture class that has a instance of B.

Instance Variables
	composite:		<Object>

composite
	- xxxxx
!

!A methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/4/2013 18:32'!
composite
^composite! !

!A methodsFor: 'as yet unclassified' stamp: 'Anonymous 5/4/2013 18:33'!
composite: unComposite
composite := unComposite.! !

Object subclass: #B
	instanceVariableNames: 'variable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test-Fixture'!

!B commentStamp: '<historical>' prior: 0!
A B is a fixture class.

Instance Variables
!

!B methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:15'!
mensajeConMetodoRequerido
^'metodo requerido: ', self mensajeSimple! !

!B methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:19'!
mensajeConUnaVariableDeInstacia
^'Variable: ', variable! !

!B methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:11'!
mensajeSimple
^'hola' ! !

B subclass: #B1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test-Fixture'!

!B1 commentStamp: '<historical>' prior: 0!
A B1 is xxxxxxxxx.

Instance Variables
!

!B1 methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:16'!
mensajeSimple
^'Clase B1'! !

B1 subclass: #B11
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test-Fixture'!

!B11 commentStamp: '<historical>' prior: 0!
A B11 is xxxxxxxxx.

Instance Variables
!

!B11 methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:17'!
mensajeSimple
^'Clase B11'! !

B1 subclass: #B12
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test-Fixture'!

!B12 commentStamp: '<historical>' prior: 0!
A B12 is xxxxxxxxx.

Instance Variables
!

!B12 methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:17'!
mensajeSimple
^'Clase B12'! !

B subclass: #B2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5-Test-Fixture'!

!B2 commentStamp: '<historical>' prior: 0!
A B2 is xxxxxxxxx.

Instance Variables
!

!B2 methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 11:17'!
mensajeSimple
^'Clase B2'! !

Object subclass: #ConvertidorATraits
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-Metaprogramacion-2.5'!

!ConvertidorATraits commentStamp: '<historical>' prior: 0!
A ConvertidorATraits is xxxxxxxxx.

Instance Variables
!

!ConvertidorATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 14:24'!
agregarMensajeRequerido: mr alTrait: nuevoTrait
nuevoTrait class compile: mr selector, '
self requiredMethods'! !

!ConvertidorATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 13:56'!
crearTraitDe: unaClase conMensajes: mensajesQueProvee
|nuevoTrait mensajesAgregarAlTrait mensajesRequeridosDelTrait|
"creo un trait con nombre T + nombre de la clase"
nuevoTrait := Trait named: ('T', unaClase class name) uses: {}  category:  unaClase class category.

"tener en cuenta que los mensajes pueden utilizar variables de intancia que hay que reemplazarlas por mensajes de acceso y otros mensajes. 
Tanto los mensajes de acceso a las variables y los demas mensajes que se estan utilizando tienen que ser los requeridos por el trait"
"el codigo de los mensajes que utilizan variables no se pueden copiar directamente, es necesario reemplazar la variable por un mensaje de acceso"
"obtener los mensajes requeridos del trait"
mensajesRequeridosDelTrait := self obtenerMensajesRequeridosDelTraitDe: unaClase paraLosMensajes: mensajesQueProvee.
 "agregar mensaje requerido"
mensajesRequeridosDelTrait do: [:mr | self agregarMensajeRequerido: mr alTrait: nuevoTrait].
"agrego cada mensaje al trait reemplazando variables por accesos"
"obtengo los mensajes que estan en la clase que tienen que ir en el nuevo trait"
mensajesAgregarAlTrait := mensajesQueProvee collect: [:m | unaClase class >> m].
"agrego el mensaje al trait"
mensajesAgregarAlTrait do: [:m | nuevoTrait compile:  m getSource].
^nuevoTrait .! !

!ConvertidorATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 14:39'!
obtenerMensajesRequeridosDelTraitDe: unaClase paraLosMensajes: mensajesQueProvee
|mensajesRequeridos|
"obtener los mensajes que se estan utilizando dentro de la implementaciones de los mensajes que debe responder el trait"
^mensajesRequeridos ! !

!ConvertidorATraits methodsFor: 'as yet unclassified' stamp: 'MarceloWieja 5/7/2013 10:53'!
refactorATraitsDe: unaClase conComposite: unComposite
|nuevoTrait mensajesQueProveeTrait|
"por cada clase en la jerarquia creo un trait --> estoy asumiendo que todas las clases son concretas y se crea un trait por cada una"
mensajesQueProveeTrait := unComposite class methodDictionary.
"Creo Trait de la clase padre"
nuevoTrait := self crearTraitDe: unComposite  conMensajes: mensajesQueProveeTrait.
"Creo Traits para las clases hijas"
unaClase class allSubclasses do:[:s | self crearTraitDe: s conMensajes: mensajesQueProveeTrait].
"hacer que una clase use un trait (usa el trait que se genera a partir de la clase padre de la jerarquia)"
unaClase useTrait: nuevoTrait.
! !
